#!/usr/local/bin/perl -w
# -*- mode:perl -*-
#
# $Source: /tmp_mnt/net/dworshak2/users/student/evans911/prog/cs481/src/RCS/cca.pl,v $
# $Author: evans911 $
# Current revision: $Revision: 0.31 $
# Last modified: $Date: 1996/12/10 21:15:53 $
# State of current revision: $State: Exp $
# Currently locked by: $Locker:  $
#
# Description: Main file that calls all others.
#              
# $Log: cca.pl,v $
# Revision 0.31  1996/12/10 21:15:53  evans911
# Changed usage statement to something (hopefully) easier to understand.
# Added simple check to see if outfile and graphfile are the same.
#
# Revision 0.30  1996/12/06 01:01:38  evans911
# Added code to check which version of Perl is being used.
#
# Revision 0.29  1996/11/13 01:22:40  evans911
# Added print statement to tell why no summary report is generated in
# the case where no report options are activated.
#
# Revision 0.28  1996/11/13 01:14:04  evans911
# Added check to keep from printing a summary report if no output
# options are true.
#
# Revision 0.27  1996/11/13 00:31:37  evans911
# Changed usage statement to indicate optional scale factor.
#
# Revision 0.26  1996/11/13 00:30:39  evans911
# Added default scale factor p.
#
# Revision 0.25  1996/11/12 23:56:51  evans911
# Cleaned up comments.
#
# Revision 0.24  1996/11/11 20:26:24  evans911
# Changed usage statement to add new scale factors.
#
# Revision 0.23  1996/11/11 19:14:31  evans911
# Made modifications to add two scale factors.
#
# Revision 0.22  1996/11/08 00:33:05  evans911
# Now passing stack by reference in certain places.
#
# Revision 0.21  1996/11/07 22:19:29  evans911
# Added extra status output.
# Added parameter to gen_image().
#
# Revision 0.20  1996/10/28 22:27:05  evans911
# Modified $stack_item_size since there are now 3 less items in the list.
#
# Revision 0.19  1996/10/25 18:06:09  evans911
# Removed calls to compute_block_totals() and sort_stack(), now that
# gen_image() isn't using that data anymore.
#
# Revision 0.18  1996/10/23 19:56:54  evans911
# Major overhaul of the command line parser.
#
# Revision 0.17  1996/10/17 20:47:49  evans911
# Added total LOC to parameter list for gen_image.
#
# Revision 0.16  1996/10/16 01:51:27  evans911
# Made modifications to call graph generating routines.
# Changed command line usage to include a scale factor (attached to -g).
#
# Revision 0.15  1996/10/10 06:05:47  evans911
# Commented out debugging spew.
#
# Revision 0.14  1996/10/09 22:43:07  jone9333
# Added a call to a new error finding function, verify_cclogic().
# This function is only called if no graph file is specified.
# Otherwise (A graphfile is to be generated) compute_block_totals
# is called as before, followed by sort_stack.
#
# Revision 0.13  1996/10/03 18:56:55  jone9333
# Changed usage report to show that -e was the default (Don't
# print the expression use summary), rather than -E.
#
# Revision 0.12  1996/10/02 01:41:21  evans911
# Commented out some debugging spew.
#
# Revision 0.11  1996/10/01 23:27:31  evans911
# Commented out the calls to Noah's graph code (for real this time).
# It turns out that there was nothing wrong with the $graphfile variable.
#
# Revision 0.10  1996/09/30 07:07:28  evans911
# Commented out call to the PostScript generator.  I shouldn't have
# had to do this, because the call shouldn't be reached unless
# $graphfile is reached.  That means that the command line parser is
# behaving incorrectly.
#
# Revision 0.9  1996/09/30 05:28:23  suthe922
# added call to assign_position for graphical output
#
# Revision 0.8  1996/09/29 04:45:36  suthe922
# added require for assign_position.pl.
#
# Revision 0.7  1996/09/29 03:45:33  jone9333
# Made -E switch off by default.
#
# Revision 0.6  1996/09/26 20:20:03  jone9333
# No significant changes.
#
# Revision 0.5  1996/09/25 03:43:38  jone9333
# Changed P switches to V's.
# Added C switch to create complete list of conditional
# logic.
# Other minor changes.
#
# Revision 0.4  1996/09/19 00:16:45  jone9333
# Removed -c and -C options within the command line switch parser.
#
# Revision 0.3  1996/09/18 02:02:54  evans911
# Added basic glue logic.  Seems to work, except that we need to remove
# VGcode from the possible options.
#
# Revision 0.2  1996/09/09 04:06:16  cary8741
# fix on flag order asseptance
# Revision 0.1  1996/09/07 08:00:47  evans911
# Initial revision.  Not thoroughly tested, but it seems to work well.
#

# Check whether this version of Perl will work before doing anything else.
# Unfortunately, Perl parses the whole file before running anything, so we 
# get parse errors if using anything before 5.000.
if ($] < 5.001)
{
    print STDERR
	"Error: Perl version $] is not capable of running this program.\n";
    print STDERR
	"       You need at least Perl 5.001 (preferrably 5.002 or above).\n";
    exit(-1);
}
elsif ($] == 5.001)
{
    print STDERR
	"Warning: Perl $] has memory limits on scalar (string) size.\n";
    print STDERR
       "         You may not be able to successfully run large input files.\n";
}

require "process_c_file.pl";
require "stack.pl";
require "vg.pl";
require "gen_report.pl";
require "gen_image.pl";
require "assign_position.pl";
require "verify.pl";
require "ps.pl";

# parse command line parameters
($C, 
 $D, 
 $E, 
 $L, 
 $T, 
 $V, 
 $outfile, 
 $scale_factor, 
 $graphfile, 
 $infile
 ) = &parse_cmd_line();

# scan input file
print STDERR "Processing file...\n";
($LOC, $CCD_Vg, $CCD_Vgp, @CCD_list) = &process_file($infile);

$stack_item_size = 7; # 7 elements in an item

# verify that CCD logic is more or less legal
print STDERR "Verifying conditional logic...\n";
&verify_cclogic($infile, $stack_item_size, @CCD_list);

# graph generation
if (defined ($graphfile))
{
    print STDERR "Preprocessing for image...\n";
    ($max_x, $max_y)
	= &assign_position($stack_item_size, \@CCD_list);

    print STDERR "Generating image...\n";
    &gen_image($graphfile,
	       $infile,
	       $stack_item_size,
	       $max_x,
	       $max_y,
	       $LOC,
	       $scale_factor,
	       \@CCD_list
	       );
}

# call report generator
if (($C == 1) || ($D == 1) || ($E == 1) || ($L == 1) || ($T == 1) || ($V == 1))
{
    print STDERR "Generating report...\n";
    &gen_report($C, 
		$D, 
		$E, 
		$L, 
		$T,
		$V,
		$outfile, 
		$infile, 
		$LOC, 
		$CCD_Vg, 
		$CCD_Vgp, 
		$stack_item_size,
		\@CCD_list);
}
else
{
    print STDERR "No summary report generated because no report options are activated.\n";
}

print STDERR "Done!\n";

# end of main code

#
# Subroutine: parse_cmd_line()
# Arguments: 
#            
# Return Values: 
#                $C            : complete logic listing
#                $D            : directive summary
#                $E            : expression listing
#                $L            : LOC
#                $T            : LOConditionals
#                $V            : VGconditionals
#                $outfile      : ouput file (optional)
#                $scale_factor : graph scale factor (optional)
#                $graphfile    : graph output file (optional)
#                $infile       : code input file
# Globals Used: @ARGV, $0
#               
# Required Files: 
#                 
# Author: Jason Evans
#
# Description: Parses the command line parameters according to the grammar
#              specified in &print_usage().
#              
sub parse_cmd_line
{
    # set defaults
    my ($C) = 1; # print complete logic listing
    my ($D) = 0; # don't print directive summary
    my ($E) = 0; # don't print expression summary
    my ($L) = 1; # print total lines of conditional code
    my ($T) = 1; # print total lines of code
    my ($V) = 1; # print V(g) and V'(g)
    my ($outfile);
    my ($scale_factor);
    my ($graphfile);
    my ($infile);

    my ($curr_arg);
    my ($i, $letters);
    my $opts = "CcDdEeLlTtVv";

    if ($#ARGV == -1) # if (no args)
    {
	print STDERR "No parameters specified.\n";
	print STDERR "Type \"$0 -h\" for command usage.\n";
	exit(-1);
    }

    #
    # parse command line parameters
    #
    for ($curr_arg = 0; $curr_arg <= $#ARGV; $curr_arg++)
    {
	# -f <infile>
	if ($ARGV[$curr_arg] =~ /^-f$/)
	{
	    unless ($curr_arg < $#ARGV)
	    {
		print STDERR "<infile> expected at end of command line.\n";
		print STDERR "Type \"$0 -h\" for command usage.\n";
		exit(-1);
	    }
	    $curr_arg++;
	    $infile = $ARGV[$curr_arg];
	}

	# -g{p|1|2|4|8|16} <graphfile>
	elsif ($ARGV[$curr_arg] =~ /^-g(.*)$/)
	{
	    $scale_factor = $1;
	    if ($scale_factor eq "")
	    {
		$scale_factor = 'p';
	    }

	    unless ($curr_arg < $#ARGV)
	    {
		print STDERR "<graphfile> expected at end of command line.\n";
		print STDERR "Type \"$0 -h\" for command usage.\n";
		exit(-1);
	    }
	    $curr_arg++;
	    $graphfile = $ARGV[$curr_arg];
	}

	# -o <outfile>
	elsif ($ARGV[$curr_arg] =~ /^-o$/)
	{
	    unless ($curr_arg < $#ARGV)
	    {
		print STDERR "<outfile> expected at end of command line.\n";
		print STDERR "Type \"$0 -h\" for command usage.\n";
		exit(-1);
	    }
	    $curr_arg++;
	    $outfile = $ARGV[$curr_arg];
	}
	
	# -h|-help|-?
	elsif ($ARGV[$curr_arg] =~ /^-(h|help|\?)$/)
	{
	    if ($#ARGV == 0)
	    {
		&print_usage();
		exit(0);
	    }
	    else
	    {
		print STDERR "Help must be specified as the only parameter.\n";
		print STDERR "Type \"$0 -h\" for command usage.\n";
		exit(-1);
	    }
	}

	# -{CcDdEeLlTtVv}+
	elsif ($ARGV[$curr_arg] =~ /^-(.*)/)
	{
	    $letters = $1;

	    for ($i = 0; $i < length($letters); $i++)
	    {
		if ($letters =~ /^[$opts]{$i}C/)
		{
		    $C = 1;
		}
		elsif ($letters =~ /^[$opts]{$i}c/)
		{
		    $C = 0;
		}
		elsif ($letters =~ /^[$opts]{$i}D/)
		{
		    $D = 1;
		}
		elsif ($letters =~ /^[$opts]{$i}d/)
		{
		    $D = 0;
		}
		elsif ($letters =~ /^[$opts]{$i}E/)
		{
		    $E = 1;
		}
		elsif ($letters =~ /^[$opts]{$i}e/)
		{
		    $E = 0;
		}
		elsif ($letters =~ /^[$opts]{$i}L/)
		{
		    $L = 1;
		}
		elsif ($letters =~ /^[$opts]{$i}l/)
		{
		    $L = 0;
		}
		elsif ($letters =~ /^[$opts]{$i}T/)
		{
		    $T = 1;
		}
		elsif ($letters =~ /^[$opts]{$i}t/)
		{
		    $T = 0;
		}
		elsif ($letters =~ /^[$opts]{$i}V/)
		{
		    $V = 1;
		}
		elsif ($letters =~ /^[$opts]{$i}v/)
		{
		    $V = 0;
		}
		elsif ($letters =~ /^[$opts]{$i}T/)
		{
		    $T = 1;
		}
		elsif ($letters =~ /^[$opts]{$i}t/)
		{
		    $T = 0;
		}
		else
		{
		    $letters =~ /^[$opts]{$i}(.)/;
		    print STDERR "Invalid or out of context flag \"$1\".\n";
		    print STDERR "Type \"$0 -h\" for command usage.\n";
		    exit(-1);
		}
	    }
	}
	else
	{
	    print STDERR "Invalid or out of order command line parameter.\n";
	    print STDERR "Type \"$0 -h\" for command usage.\n";
	    exit(-1);
	}
    }

    #
    # test validity of the return variables
    #
    unless (defined($infile))
    {
	print STDERR "No input file specified.\n";
	print STDERR "Type \"$0 -h\" for command usage.\n";
	exit(-1);
    }
    unless (-e $infile)
    {
	print STDERR "Invalid or non-existant input file \"$infile\".\n";
	print STDERR "Type \"$0 -h\" for command usage.\n";
	exit(-1);
    }
    if (defined ($scale_factor))
    {
	unless ($scale_factor =~ /^(p|1|2|4|8|16)$/)
	{
	    print STDERR "Invalid graph scale factor \"$scale_factor\".\n";
	    print STDERR "Type \"$0 -h\" for command usage.\n";
	    exit(-1);
	}
    }
    if (defined($outfile) && defined($graphfile))
    {
	if ($outfile eq $graphfile)
	{
	    print STDERR 
		"Warning: Same filename specified for report and graph.\n";
	}
    }

    return ($C, $D, $E, $L, $T, $V, 
	    $outfile, $scale_factor, $graphfile, $infile);
}

#
# Subroutine: print_usage()
# Arguments: 
#            
# Return Values: 
#                
# Globals Used: 
#               
# Required Files: 
#                 
# Author: Jason Evans
#
# Description: Prints a command line usage statement.
#              
sub print_usage
{
    my (@path, $progname);

    # get program name without path
    (@path) = split(/\//, $0);
    $progname = $path[$#path];

    print STDERR "$progname usage:\n";
    print STDERR "             $progname <option>* -f infile\n";
    print STDERR "             $progname -h | -help | -?\n";
    print STDERR "\n";
    print STDERR "                 option ::=  -{CcDdEeLlTtVv}+\n";
    print STDERR "                           | -g[p|1|2|4|8|16] <graphfile>\n";
    print STDERR "                           | -o <outfile>\n";
}
