#!/usr/local/bin/perl -w
#
# $Source: /tmp_mnt/net/dworshak2/users/student/evans911/prog/cs481/src/RCS/stack.pl,v $
# $Author: evans911 $
# Current revision: $Revision: 1.25 $
# Last modified: $Date: 1996/10/28 22:27:53 $
# State of current revision: $State: Exp $
# Currently locked by: $Locker:  $
#
# Description: Stack functions used to post-process the information pulled
#              out of the C file by process_c_file.pl.
#              
# $Log: stack.pl,v $
# Revision 1.25  1996/10/28 22:27:53  evans911
# Deleted almost all of the subroutines, since nothing is using them.
#
# Revision 1.24  1996/10/17 19:41:47  jone9333
# Added a lot more commenting of the source code.
#
# Revision 1.23  1996/10/16 22:35:35  jone9333
# removed some debugging spew.
#
# Revision 1.22  1996/10/16 22:25:10  jone9333
# Fixed a bug in compute_block_totals which incorrectly computed
# block lines of code.
#
# Revision 1.21  1996/10/10 19:25:02  jone9333
# Removed error checking code from compute_block_totals(). This
# is now done entirely in verify_cclogic() for all input files.
#
# Revision 1.20  1996/10/09 22:44:32  evans911
# Removed dummy driver and added author to comment blocks.
#
# Revision 1.19  1996/10/09 19:12:33  jone9333
# Replaced sort_stack() with new, faster sort function.
# The new sort function was sort_stack2 in the previous code
# revision.
# .,
#
# Revision 1.18  1996/10/04 21:33:02  jone9333
# added a new sort function. It's still under development.
#
# Revision 1.17  1996/10/02 02:35:40  jone9333
# Added code in the compute_block_totals function which checks
# for empty lists. (Correctly handles files with no conditional
# compilation logic in them).
#
# Revision 1.16  1996/10/01 23:34:18  evans911
# Removed a straggling "w".
#
# Revision 1.15  1996/10/01 23:27:58  jone9333
# No changes.
#
# Revision 1.14  1996/09/29 03:29:21  jone9333
# Added more informative error reporting in comput_block_totals().
#
# Revision 1.13  1996/09/29 03:10:08  jone9333
# Fixed a variable name bug in get_sublist().
#
# Revision 1.12  1996/09/29 02:38:49  jone9333
# Added function to return a particular sublist from the stack.
#
# Revision 1.11  1996/09/18 23:10:59  jone9333
# Fixed Compute_block_totals to identify both missing and unmatched
# #endif directives.
#
# Revision 1.10  1996/09/18 22:43:31  jone9333
# Changed sort_stack and pop_stack to use the "splice" perl command rather
# than multiple shifts and other moves which ate up time.
#
# Revision 1.9  1996/09/18 20:20:16  jone9333
# Added some debugging spew to find errors due to having empty expressions
# in compute clock totals.
#
# Revision 1.8  1996/09/18 02:07:35  evans911
# Modified &compute_block_totals() to correctly handle breaks between
# nested #CCD's. (Sean)
#
# Revision 1.7  1996/09/17 23:16:18  jone9333
# No significant changes
#
# Revision 1.6  1996/09/17 03:28:34  evans911
# Commented out dummy driver (again).  Added some comments.
#
# Revision 1.5  1996/09/14 03:24:03  jone9333
# Added sort_stack function, which does just that.
# Modified function calls and return types for pop_stack and push_stack.
# Modifications dealt with sending data by reference instead of by value.
# This eliminates messy parsing after calls and returns.
#
# Revision 1.4  1996/09/09 08:43:31  jone9333
# Added a function to compute block totals for LOC, McCabes for code,
# & McCabes for conditionals, given a list of conditional lines with
# running totals for the above statistics.
#
# Revision 1.3  1996/09/09 01:17:48  jone9333
# Added another variable to stack group.  This variable stores the number
# of lines of code within a conditional block.
#
# Revision 1.2  1996/09/07 08:00:15  evans911
# Added comment blocks.
# Added 1; to end of file.
# Commented out dummy driver.
#

#
# Subroutine: size_stack($Data_Size, @Stack)
#
# Arguments: $Data_Size : number of elements in one stack item
#            @Stack     : the stack
#            
# Return Values: $Size : # of items on the stack
#                
# Globals Used:  
#               
# Required Files: 
#                 
# Author: Sean Jones
#
# Description: Given a stack, return the size of the stack.
#              
sub size_stack{

    my ($Data_Size,@Stack) = @_;
    
    # Number of items = total elements / # of elements per item
    $Size = (($#Stack + 1)/$Data_Size);

    return ($Size);
}

1;
