// -*- C++ -*-

#ifndef _ALIGNEDSUPERBLOCKHEAP_H_
#define _ALIGNEDSUPERBLOCKHEAP_H_

#include "mmapheap.h"
#include "sassert.h"

#include "conformantheap.h"
#include "lockedheap.h"
#include "fixedrequestheap.h"

#if 0 // defined(_WIN32)

//#include "winmmapheap.h"

// FIX ME : magic 256K number below...

template <class TheLockType,
	  size_t SuperblockSize>
class AlignedSuperblockHeap :
  public ConformantHeap<HL::LockedHeap<TheLockType,
				       HL::FixedRequestHeap<SuperblockSize, 
							    WinMmapHeap<SuperblockSize, 256 * 1024> > > > {};

#else

// Always requests aligned superblocks.
#include "alignedmmap.h"
//#include "unixmmapheap.h"

template <class TheLockType,
	  size_t SuperblockSize>
class AlignedSuperblockHeapHelper :
  public ConformantHeap<HL::LockedHeap<TheLockType,
				       FixedRequestHeap<SuperblockSize, 
		   AlignedMmap<SuperblockSize> > > > {};

template <class TheLockType,
	  size_t SuperblockSize>
class AlignedSuperblockHeap :
  public AlignedSuperblockHeapHelper<TheLockType, SuperblockSize> {
private:
  HL::sassert<(AlignedSuperblockHeapHelper<TheLockType, SuperblockSize>::Alignment % SuperblockSize == 0)> EnsureProperAlignment;
};

#endif

#endif
